      implicit double precision (a-h,o-z)                               
      dimension P(7),QA(10000),PE(7)                                    
      parameter(NChap=8)!!CRC NChap=11 for full REACLIB
      INTEGER K1(NChap),IT9(24)  
      character*4 LEC,LKH,LWH,LRAT                               
      character*5 NAM(6),INAM(10000),NAMW(2,10000)                         
      character*1 vw,nr,nr0,vw0                                         
      COMMON /NA/ INAM                                                  
      DATA K1/2,3,4,3,4,5,6,5/,LRAT/' ffn'/,nr0/' '/,vw0/' '/           
CRC      DATA K1/2,3,4,3,4,5,6,4,5,6,5/,LRAT/' ffn'/,nr0/' '/,vw0/' '/           
      data lwh/'    '/
C--------------------------------------------------------------------C  
C           search.f                                                 C  
C   THIS PROGRAM IS SEARCHING FOR THE NUCLEI GIVEN IN FILE1          C  
C  THROUGH THE REACTION RATE LIBRARY (FILE5) AND PROVIDES A          C  
C  REDUCED RATE LIBRARY FOR THE ACTUAL NETWORK ON FILE3.             C  
c  it also produces a reduced version of the nuclear data            c
c  of file8 in file9 (names, mass excess and partition               c
c  functions).                                                       c
C  IF THE SIMPLE BETA HALF-LIVES SHALL BE OVERWRITTEN BY             C  
C  THE ELECTRON-CAPTURE AND WEAK INTERACTION RATES OF                C  
C  FULLER, FOWLER AND NEWMAN THOSE DATA HAVE TO BE PROVIDED          C  
C  IN FILE2 AND AGAIN A REDUCED VERSION IS CREATED (FILE4)           C  
c  when you only want to take experimental beta rates                c
c  use the NM=0!!!!!!! after call weak                               c
C                                                                    C  
C--------------------------------------------------------------------C  
      open(1,file='INPUT/sunet')                                              
C      open(2,file='INPUT/ffnu')                                
      open(2,file='INPUT/blank')                                
      open(3,file='netsu')                                              
C      open(4,file='netweak')                                            
      open(7,file='INPUT/rawreaclib')                          
      nline=0
      N=0                                                               
      NL=0                                                              
      KB=0                                                              
      LW=0                                                              
      KLK=0                                                             
   15 N=N+1                                                             
      READ(1,410,END=16) INAM(N)                                        
      GOTO 15                                                           
   16 N=N-1                                                             
      WRITE(6,1010)(INAM(I),I=1,N)                                      
      call zan(n)
c********************************************************************
c
      CALL WEAK(NAMW,QA,NM,N)                                           
c     NM=0                                                              
c
c********************************************************************
      WRITE(3,2000) NM                                                  
c     READ(7,400) LEC,LWH                                               
c     WRITE(3,400) LEC,LWH                                              
c     READ(7,230) (IT9(I),I=1,24)                                       
c     WRITE(3,230) (IT9(I),I=1,24)                                      
      GOTO 20                                                           
   10 KK=K                                                              
      KL=K1(KK)                                                         
      GOTO 20                                                           
   18 NL=L                                                              
   20 READ(7,300,END=90,ERR=121) K,(NAM(J),J=1,6),LKH,nr,vw,Q                   
      READ(7,310,ERR=122) (P(J),J=1,7)                                          
      nline=nline+3
c     write(6,300) K,(NAM(J),J=1,6),LKH,nr,vw,Q                   
c     write(6,310) (P(J),J=1,7)                                          
      IF(K.NE.2) GOTO 70                                                
      IF(NL.EQ.N) GOTO 70                                               
      goto 123
  121 write(6,*) 'ERROR: header line', nline
      stop
  122 write(6,*) 'ERROR: body line', nline
      write(6,300) K,(NAM(J),J=1,6),LKH,nr,vw,Q                   
      write(6,310) (P(J),J=1,7)                                          
      stop
  123 continue
      L=N+1                                                             
      NL=NL+1                                                           
      KB=1                                                              
      GOTO 23                                                           
   70 IF(K.NE.0) GOTO 80                                                
      DO 30 I=1,KL                                                      
      IF(NAM(I).EQ.LWH) GOTO 30                                         
      CALL BENAM(NAM(I),N,L)                                            
      IF(L.EQ.0) GOTO 20                                                
   30 CONTINUE                                                          
      IF(KK.NE.1) GOTO 80                                               
      NL=NL+1                                                           
      CALL BENAM(NAM(1),N,L)                                            
c     write(6,1050) nam(1),nl,l
      IF(NL.LT.L) GOTO 23                                               
   27 CALL SUWEAK(NAM(1),NAMW,NM,LW,LW2)                                
c     write(6,1050) nam(1),nl,l,lw,lw2
      IF(NL.GT.L.AND.LW.NE.0) GOTO 18                                   
      NL=L                                                              
      IF(LW.EQ.0) GOTO 80                                               
   22 PE(1)=DFLOAT(LW)                                                  
      DO 24 I=2,7                                                       
   24 PE(I)=0.D0                                                        
      LKH=LRAT                                                          
      WRITE(3,300) K,NAMW(1,LW),NAMW(2,LW),(NAM(J),J=3,6),LRAT,         
     *       nr0,vw0,QA(LW)                                             
      WRITE(3,310) (PE(J),J=1,7)                                        
   50 IF(LW.EQ.LW2.OR.LW2.EQ.0) GOTO 85                                 
      LW=LW2                                                            
      GOTO 22                                                           
   23 LL=L-1                                                            
      DO 25 I=NL,LL                                                     
      CALL SUWEAK(INAM(I),NAMW,NM,LW,LW2)                               
      IF(LW.EQ.0) GOTO 25                                               
   40 PE(1)=DFLOAT(LW)                                                  
      DO 26 J=2,7                                                       
   26 PE(J)=0.D0                                                        
      WRITE(3,300) KLK,NAMW(1,LW),NAMW(2,LW),(NAM(J),J=3,6),LRAT,       
     *       nr0,vw0,QA(LW)                                             
      WRITE(3,310) (PE(J),J=1,7)                                        
   60 IF(LW.EQ.LW2.OR.LW2.EQ.0) GOTO 25                                 
      LW=LW2                                                            
      GOTO 40                                                           
   25 CONTINUE                                                          
      IF(KB.EQ.1) GOTO 70                                               
      GOTO 27                                                           
   80 if(K.le.NChap)then !CRC
         WRITE(3,300) K,(NAM(J),J=1,6),LKH,nr,vw,Q                         
         WRITE(3,310)(P(J),J=1,7)                                          
      endif !CRC
   85 IF(K) 10,20,10                                                    
  400 FORMAT(2A4)                                                       
  410 FORMAT(2A5)                                                       
  230 FORMAT(24I3)                                                      
  300 FORMAT(I2,3X,6A5,8X,A4,a1,a1,3X,1pE12.5)                          
  310 FORMAT(4E13.6)                                                    
  500 FORMAT(1X,I2,6A4,6I2,2E10.4/1X,7E10.4)                            
 1010 FORMAT(1X,15A5)                                                   
 1050 format(1x,a5,5i8)
 2000 FORMAT(I5)                                                        
   90 continue
      if(NM.eq.0) write(6,*) 'WARNING: no ffnu used/found'
      STOP                                                              
      END                                                               
      SUBROUTINE BENAM(NAM,N,I)                                         
      character*5 INAM(10000),NAM                                         
      COMMON /NA/ INAM                                                  
      DO 10 I=1,N                                                       
      IF(NAM.EQ.INAM(I)) GOTO 20                                        
   10 CONTINUE                                                          
      I=0                                                               
   20 RETURN                                                            
      END                                                               
      SUBROUTINE WEAK(NAMW,Q,NM,N)                                      
      implicit double precision (a-h,o-z)                               
      DIMENSION EB(2),Q(10000),I1(2)                                      
      DIMENSION SUM1(143),SUM2(143),ENU1(143),ENU2(143)                 
      character*5 NAM(9),BLANK,NAME(2)                                  
      character*5 NAMW(2,10000),CENAM,NKU                            
      character*4 lrat
      character*1 null
      DATA BLANK/'     '/,LRAT/' ffn'/                                   
      NM=0                                                              
      NEND=0                                                            
    5 READ(2,1000,END=80) NAM                                           
      DO 10 I=1,9                                                       
      IF(NAM(9+1-I).EQ.BLANK) GOTO 10                                   
      KL=9-I                                                            
      GOTO 20                                                           
   10 CONTINUE                                                          
   20 DO 60 K=1,KL                                                      
      READ(2,2000)  NAME(1),EB(1)                                       
      READ(2,2000) NAME(2),EB(2)                                        
      READ(2,3000) NULL                                                 
      READ(2,3000) NULL                                                 
      ISHIT=0                                                           
      DO 40 L=1,2                                                       
      call renam(name(l))
      CALL BENAM(NAME(L),N,I1(L))                                       
      IF(I1(L).NE.0) GOTO 40                                            
      NKU=CENAM(NAME(L))                                                
      NAME(L)=NKU                                                       
      CALL BENAM(NAME(L),N,I1(L))                                       
      IF(I1(L).EQ.0) ISHIT=1                                            
   40 CONTINUE                                                          
      DO 50 I=1,143                                                     
      IF(ISHIT.EQ.1) GOTO 45                                            
      READ(2,4000,END=70) SUM1(I),ENU1(I),SUM2(I),ENU2(I)               
      GOTO 50                                                           
   45 READ(2,3000,END=70) NULL                                          
   50 CONTINUE                                                          
      READ(2,3000) NULL                                                 
      GOTO 55                                                           
   70 NEND=1                                                            
   55 IF(ISHIT.EQ.1) GOTO 56                                            
      NM=NM+1                                                           
      NAMW(1,NM)=NAME(1)                                                
      NAMW(2,NM)=NAME(2)                                                
      Q(NM)=EB(1)-EB(2)                                                 
      NM=NM+1                                                           
      NAMW(1,NM)=NAME(2)                                                
      NAMW(2,NM)=NAME(1)                                                
      Q(NM)=-Q(NM-1)                                                    
      WRITE(4,5000) NAME(1),NAME(2),LRAT,Q(NM-1)                        
      WRITE(4,6000) (SUM1(I),ENU1(I),I=1,143)                           
      WRITE(4,5000) NAME(2),NAME(1),LRAT,Q(NM)                          
      WRITE(4,6000) (SUM2(I),ENU2(I),I=1,143)                           
   56 IF(NEND.EQ.1) GOTO 80                                             
   60 CONTINUE                                                          
      GOTO 5                                                            
 1000 FORMAT(9X,9A5)                                              
 2000 FORMAT((14X,A5,25X,F8.4))                                         
 3000 FORMAT(A1)                                                        
 4000 FORMAT(32X,2(F8.3),16X,2(F8.3))                                   
 5000 FORMAT(5X,2A5,28X,A4,5X,1pE12.5)                                    
 6000 FORMAT(9(F8.3))                                                   
   80 RETURN                                                            
      END                                                               
      FUNCTION CENAM(NAME)                                              
      character*5 CENAM,NAME,INAM(58),WNAM(58)                              
      DATA WNAM/' h1  ',
     *          ' n01 ',' f21 ',' o21 ',' f22 ',' f23 ',' p27 ',' s28 ',
     *  ' p28 ',' s29 ',' p29 ',' s30 ',' p30 ',' s31 ',' p31 ',' s32 ',
     *  ' p32 ',' s33 ',' p33 ',' s34 ',' p34 ',' k35 ',' s35 ',' p35 ',
     *  ' k36 ',' s36 ',' k37 ',' s37 ',' k38 ',' s38 ',' k39 ',' k40 ',
     *  ' k41 ',' k42 ',' k43 ',' v44 ',' k44 ',' v45 ',' k45 ',' v46 ',
     *  ' k46 ',' v47 ',' k47 ',' v48 ',' k48 ',' v49 ',' k49 ',' v50 ',
     *  ' v51 ',' v52 ',' v53 ',' v54 ',' v55 ',' v56 ',' v57 ',' v58 ',
     *  ' v59 ',' v60 '/                                          
      DATA INAM/'    p',
     *          '    n','  f21','  o21','  f22','  f23','  p27','  s28',
     *  '  p28','  s29','  p29','  s30','  p30','  s31','  p31','  s32',
     *  '  p32','  s33','  p33','  s34','  p34','  k35','  s35','  p35',
     *  '  k36','  s36','  k37','  s37','  k38','  s38','  k39','  k40',
     *  '  k41','  k42','  k43','  v44','  k44','  v45','  k45','  v46',
     *  '  k46','  v47','  k47','  v48','  k48','  v49','  k49','  v50',
     *  '  v51','  v52','  v53','  v54','  v55','  v56','  v57','  v58',
     *  '  v59','  v60'/                                          
      DO 10 I=1,58                                                      
      IF(NAME.NE.WNAM(I)) GOTO 10                                       
      CENAM=INAM(I)                                                     
      GOTO 20                                                           
   10 CONTINUE                                                          
      CENAM=NAME                                                        
   20 RETURN                                                            
      END                                                               
      SUBROUTINE SUWEAK(NAME,NAMW,NM,LW,LW2)                            
      character*5  NAME,NAMW(2,10000)                                       
      LW=0                                                              
      LW2=0                                                             
      IF (NM.EQ.0) GOTO 20                                              
      DO 10 I=1,NM                                                      
      IF(NAME.NE.NAMW(1,I)) GOTO 10                                     
      IF(LW) 30,40,30                                                   
   30 LW2=I                                                             
      GOTO 20                                                           
   40 LW=I                                                              
   10 CONTINUE                                                          
   20 RETURN                                                            
      END                                                               
      subroutine renam(na)
      character*5 na
      character*1 nu(36),nl(36)
      data nu/'A','B','C','D','E','F','G','H','I','J','K','L','M','N',
     *        'O','P','Q','R','S','T','U','V','W','X','Y','Z',
     *        '1','2','3','4','5','6','7','8','9','0'/
      data nl/'a','b','c','d','e','f','g','h','i','j','k','l','m','n',
     *        'o','p','q','r','s','t','u','v','w','x','y','z',
     *        '1','2','3','4','5','6','7','8','9','0'/
      do 10 i=1,5
      do 10 j=1,36
      if(na(i:i).eq.nu(j)) na(i:i)=nl(j)
   10 continue
      return
      end
      SUBROUTINE ZAN(LKN)                                               
c-------------------------------------------------------------------
      parameter (nyabmx=10000)
c-------------------------------------------------------------------
      implicit double precision (a-h,o-z)
      DIMENSION ZA(nyabmx),ZP(nyabmx),ZN(nyabmx),BI(nyabmx)                     
      DIMENSION G(24)                                                   
      INTEGER MA(nyabmx)                                                  
      character*5 INAM(nyabmx),NAM(nyabmx),name                                
      character*72 line
      COMMON /ZANP/ ZA,ZP,ZN,PNP,BI                                     
      COMMON /NA/ INAM                                                  
      open(8,file='INPUT/winvn')
      open(9,file='netwinv')
C     LKN=11                                                            
C     DO 1 I=1,LKN                                                      
C   1 READ(1,1000) INAM(I)                                              
      READ( 8,1010) line                                                
      write(9,1010) line                                                
      READ( 8,1010) line                                                
      write(9,1010) line                                                
      N=0                                                               
      I=1                                                               
    5 N=N+1                                                             
      READ( 8,1000) NAM(N)                                              
      IF(N.EQ.1) GOTO 8                                                 
      IF(NAM(N).EQ.NAM(N-1)) GOTO 10                                    
    8 IF(NAM(N).NE.INAM(I)) GOTO 5                                      
      write(9,1000) NAM(N)                                              
      MA(I)=N                                                           
      I=I+1                                                             
c     if(i.gt.lkn) goto 10
      GOTO 5                                                            
   10 N=N-1                                                             
      I=1                                                               
      DO 20 L=1,LKN                                                     
C     IF(L.LE.2) GOTO 26                                                
C     READ(7,1500) BE,NA,NB                                             
C     A=NA                                                              
C     NA=NA-NB                                                          
C     GOTO 27                                                           
   26 K=MA(L)-I+1                                                       
      DO 25 J=1,K                                                       
      READ( 8,2000) NAME,A,NA,NB,SP,BE                                  
   25 READ( 8,2001) (G(M),M=1,24)                                       
   27 ZA(L)=A                                                           
      ZP(L)=DFLOAT(NA)                                                  
      ZN(L)=DFLOAT(NB)                                                  
c     BI(L)=8.07144*ZN(L)+7.28899*ZP(L)-BE                              
      BI(L)=BE                              
      I=MA(L)+1                                                         
      write(9,2000) NAME,A,NA,NB,SP,BE                                  
      write(9,2001) (G(M),M=1,24)                                       
   20 CONTINUE                                                          
c     WRITE(6,3000) (INAM(I),ZA(I),ZP(I),ZN(I),I=1,LKN)                 
 1000 FORMAT(2A5)                                                       
 1010 FORMAT(A72)                                                      
 1500 FORMAT(1X,F6.3,I4,I3,F4.1,1X,A4,1X,A4)                            
 2000 FORMAT(A5,F12.3,2I4,F6.1,F10.3)                                   
 2001 FORMAT(8F9.2)                                                     
 3000 FORMAT(1X,A5,3F15.2)                                              
      RETURN                                                            
      END                                                               
